<?php
/**
 * PlgContentHtml5chat
 * @copyright (C) 2018 PlgContentHtml5chat
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.html5-chat.com/ Official website
 **/
ini_set('display_errors', 1);
error_reporting(E_ALL);
defined('_JEXEC') or die;

class PlgContentHtml5chat extends JPlugin
{

    public function onContentPrepare($context, &$article, &$params, $page = 0)
    {
        $plugin = JPluginHelper::getPlugin('content', 'html5chat');
        if ($plugin) {
            $pluginParams = new JRegistry($plugin->params);
            $webmasterid = $pluginParams->get('webmasterid');
            $password = $pluginParams->get('password');
        }
        if (!$plugin || !$webmasterid || !$password) {
            exit("ERROR: You must provide webmasterid and password parameters in your html5chat plugin confiugration");
        }
        $shortcode = $article->text;
        if (!strpos($shortcode, 'html5chat')) {
            return;
        }

        $user = clone(JFactory::getuser());
        //print_r($user);exit();
        $db = JFactory::getDBO();
        $role = '';

        foreach ($user->groups as $group) {
            $query = 'SELECT title FROM #__usergroups  WHERE id = ' . $group;
            $db->setQuery($query);
            $role = $db->loadResult();
        }
        switch ($role) {
            case 'certifié':
                $role = 'custom1';
                break;
            case 'Super Users':
            case 'administrateur':
            case 'Administrator':
                $role = 'admin';
                break;
            case 'Author':
            case 'modérateur':
            case 'moderator':
                $role = 'moderator';
                break;
            case 'enregistré':
            case 'Registered':
                $role = 'user';
                break;
            default:
                $role = 'guest';
        }

        $role = strtolower($role);
        $shortcode = $article->text;
        // $shortcode = '';
        if (strpos($shortcode, 'html5chat')) {
            $re = '/(\w+)\s*=\s*"(.*?)"/m';
            $article->text = $shortcode;
            preg_match_all($re, $shortcode, $matches, PREG_SET_ORDER, 0);
            $parameters = array();
            foreach ($matches as $match) {
                try {
                    $parameters[$match[1]] = $match[2];
                } catch (Exception $e) {
                }
            }
        }
        $avatar = $gender = '';
        if (class_exists('CFactory')) {
            $cuser = CFactory::getUser();
            $avatar = $cuser->getThumbAvatar();
            $gender = ($cuser->getInfo('FIELD_GENDER') == 'COM_COMMUNITY_FEMALE') ? 'female' : 'male';
        }

        $width = isset($parameters['width']) ? $parameters['width'] : '100%';
        $height = isset($parameters['height']) ? $parameters['height'] : '100%';

        $myuser = array(
            'username' => $user->username,
            'role' => $role,
            'password' => $password,
            'width' => $width,
            'height' => $height,
            'image' => $avatar,
            'gender' => $gender
        );
        $myuser = array_merge($myuser, $parameters);
        $json = $json = json_encode($myuser);
        $url = 'https://html5-chat.com/protect/' . base64_encode($json);
        if (function_exists('file_get_contents')) {
            $encoded = file_get_contents($url);
        } else {
            $curl =  curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_RETURNTRANSFER => 1,
                CURLOPT_URL => $url
            ));
            $encoded = curl_exec($curl);
        }
        $script = "</script></script><script src='https://html5-chat.com/joomla/$webmasterid/$encoded'></script>";
        $article->text = $script;
        return true;
    }
}

